unit FormCPU;

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TFormCPU }

  TFormCPU = class(TForm)
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    LabelMemoryPointer: TLabel;
    LabelProgramPointer: TLabel;
    LabelStepCounter: TLabel;
    LabelStepSpeed: TLabel;
    procedure FormCreate(Sender: TObject);
  public
    LastStepCounter: Integer;
    procedure Reload;
  end;

var
  FormCPU: TFormCPU;


implementation

uses
  Core, TargetInterpretter;

{$R *.lfm}

resourcestring
  SStepsPerSecond = ' steps/s';

{ TFormCPU }

procedure TFormCPU.FormCreate(Sender: TObject);
begin
  Core.Core.Translator.TranslateComponentRecursive(Self);
  Core.Core.ThemeManager.UseTheme(Self);
end;

procedure TFormCPU.Reload;
begin
  if Core.Core.CurrentTarget is TTargetInterpretter then
  with TTargetInterpretter(Core.Core.CurrentTarget) do begin
    LabelProgramPointer.Caption := IntToStr(ProgramIndex);
    LabelMemoryPointer.Caption := IntToStr(MemoryPosition);
    LabelStepCounter.Caption := IntToStr(StepCount);
    LabelStepSpeed.Caption := IntToStr(StepCount - LastStepCounter) + SStepsPerSecond;
    LastStepCounter := StepCount;
  end;
end;

end.

