unit FormCompileMultiple;

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  Target;

type

  { TFormCompileMultiple }

  TFormCompileMultiple = class(TForm)
    ButtonCompile: TButton;
    ButtonCancel: TButton;
    ListViewTargets: TListView;
    procedure ButtonCompileClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FTargets: TTargets;
  public
    procedure ReloadList;
    property Targets: TTargets read FTargets write FTargets;
  end;


implementation

{$R *.lfm}

uses
  Core;

procedure TFormCompileMultiple.FormCreate(Sender: TObject);
begin
  Core.Core.Translator.TranslateComponentRecursive(Self);
  Core.Core.ThemeManager.UseTheme(Self);
end;

procedure TFormCompileMultiple.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  Core.Core.PersistentForm1.Save(Self);
end;

procedure TFormCompileMultiple.ButtonCompileClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to ListViewTargets.Items.Count - 1 do
    TTarget(ListViewTargets.Items[I].Data).Selected :=
      ListViewTargets.Items[I].Checked;
end;

procedure TFormCompileMultiple.FormDestroy(Sender: TObject);
begin
end;

procedure TFormCompileMultiple.FormShow(Sender: TObject);
begin
  Core.Core.PersistentForm1.Load(Self);
  ReloadList;
end;

procedure TFormCompileMultiple.ReloadList;
var
  I: Integer;
  ListItem: TListItem;
begin
  if Assigned(Targets) then
  for I := 0 to Targets.Count - 1 do
  with Targets[I] do begin
    ListItem := ListViewTargets.Items.Add;
    ListItem.Caption := Name;
    ListItem.Checked := Selected;
    ListItem.Data := Targets[I];
  end;
end;

end.

