unit FormMain;

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, FormCPU, FormInput,
  Graphics, Dialogs, Menus, ActnList, ComCtrls, ExtCtrls, Target, Registry,
  LazFileUtils, FormOptions, FormMessages, FormTargets,
  FormOutput, FormMemory, FormSourceCode, FormTargetCode, FormLog,
  FormCompileMultiple;

type

  { TFormMain }

  TFormMain = class(TForm)
    AProgramCompileMultiple: TAction;
    AViewLog: TAction;
    AProgramShowExecutionPoint: TAction;
    AShowSourcePosition: TAction;
    AShowTargetPosition: TAction;
    AProgramCompile: TAction;
    AAbout: TAction;
    ABreakpointToggle: TAction;
    AViewCompilers: TAction;
    AOptions: TAction;
    AProgramStepOut: TAction;
    AProgramRunToCursor: TAction;
    AProgramStepOver: TAction;
    AProgramStepInto: TAction;
    AProgramPause: TAction;
    AProgramStop: TAction;
    AHelp: TAction;
    AProgramRun: TAction;
    AProjectNew: TAction;
    AExit: TAction;
    AProjectSaveAs: TAction;
    AProjectClose: TAction;
    AProjectSave: TAction;
    AProjectOpen: TAction;
    ActionList1: TActionList;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem28: TMenuItem;
    MenuItem30: TMenuItem;
    MenuItem31: TMenuItem;
    MenuItem32: TMenuItem;
    MenuItem33: TMenuItem;
    MenuItem34: TMenuItem;
    MenuItem35: TMenuItem;
    MenuItemOpenRecent: TMenuItem;
    MenuItemTarget: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenDialog1: TOpenDialog;
    PageControlMain: TPageControl;
    PageControlRight: TPageControl;
    PageControlBottom: TPageControl;
    PanelLeft: TPanel;
    PanelMemory: TPanel;
    PanelCPU: TPanel;
    PanelOutput: TPanel;
    PanelInput: TPanel;
    PopupMenuTargets: TPopupMenu;
    PopupMenuRecentFiles: TPopupMenu;
    SaveDialog1: TSaveDialog;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
    Splitter5: TSplitter;
    StatusBarMain: TStatusBar;
    TabSheetMessages: TTabSheet;
    TabSheetDebug: TTabSheet;
    TabSheetSource: TTabSheet;
    TabSheetTarget: TTabSheet;
    TimerRefresh: TTimer;
    ToolBarMain: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButtonTarget: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    procedure AAboutExecute(Sender: TObject);
    procedure ABreakpointToggleExecute(Sender: TObject);
    procedure AExitExecute(Sender: TObject);
    procedure AOptionsExecute(Sender: TObject);
    procedure AProgramCompileExecute(Sender: TObject);
    procedure AProgramCompileMultipleExecute(Sender: TObject);
    procedure AProgramPauseExecute(Sender: TObject);
    procedure AProgramRunToCursorExecute(Sender: TObject);
    procedure AProgramRunExecute(Sender: TObject);
    procedure AProgramShowExecutionPointExecute(Sender: TObject);
    procedure AProgramStepIntoExecute(Sender: TObject);
    procedure AProgramStepOutExecute(Sender: TObject);
    procedure AProgramStepOverExecute(Sender: TObject);
    procedure AProgramStopExecute(Sender: TObject);
    procedure AProjectCloseExecute(Sender: TObject);
    procedure AProjectNewExecute(Sender: TObject);
    procedure AProjectOpenExecute(Sender: TObject);
    procedure AProjectSaveAsExecute(Sender: TObject);
    procedure AProjectSaveExecute(Sender: TObject);
    procedure AShowSourcePositionExecute(Sender: TObject);
    procedure AShowTargetPositionExecute(Sender: TObject);
    procedure AViewCompilersExecute(Sender: TObject);
    procedure AViewInterpretterExecute(Sender: TObject);
    procedure AViewLogExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TimerRefreshTimer(Sender: TObject);
  private
    FormCPU: TFormCPU;
    FormInput: TFormInput;
    FormLog: TFormLog;
    FormMemory: TFormMemory;
    FormMessages: TFormMessages;
    FormOutput: TFormOutput;
    FormSourceCode: TFormSourceCode;
    FormTargetCode: TFormTargetCode;
    procedure AProjectOpenRecentExecute(Sender: TObject);
    procedure MenuItemTargetClick(Sender: TObject);
    procedure ProjectOpen(FileName: string);
    procedure UpdateToolBarHints;
    procedure DockForm(Form: TForm; DockSite: TWinControl);
    procedure DockInit;
    procedure LastOpenedListChange(Sender: TObject);
    procedure CurrentTargetChangeExecute(Sender: TObject);
  public
    procedure MessagesChanged(Sender: TObject);
    procedure TargetLogExecute(Lines: TStrings);
    procedure TargetStateChanged(Sender: TObject);
    procedure UpdateInterface;
    procedure UpdateStatusBar;
    procedure UpdateTargetList;
  end;


implementation

{$R *.lfm}

uses
  Core, TargetInterpretter, BFTarget, Common;

resourcestring
  SProgramStarted = 'Program started';
  SProgramStopped = 'Program stopped';
  SNewProject = 'New project';
  SCompileStart = 'Compiling...';
  SDone = 'Done';
  SChanged = 'Changed';
  SUnsavedChanges = 'Unsaved changes';
  SDoYouWantToSaveProject = 'There are unsaved changes in project. Do you want to save them?';
  SCloseProjectFirst = 'Project need to be closed before it can be openned';
  SError = 'Error';
  SFileNotFound = 'File %s not found.';

const
  ExamplesDir = 'Examples';

{ TFormMain }

procedure TFormMain.FormShow(Sender: TObject);
begin
  Core.Core.Init;
  PageControlMain.TabIndex := 0;
  try
    if Core.Core.OpenProjectOnStart and (Core.Core.LastOpenedList.Items.Count > 0) and
      FileExists(Core.Core.LastOpenedList.Items[0]) then
      ProjectOpen(Core.Core.LastOpenedList.Items[0])
      else AProjectNew.Execute;
  finally
    LastOpenedListChange(nil);
    UpdateInterface;
    UpdateToolBarHints;
    UpdateTargetList;
    DockInit;
    Core.Core.PersistentForm1.Load(Self, True);
    Core.Core.ThemeManager.UseTheme(Self);
    FormSourceCode.UpdateTheme;
  end;
  Core.Core.Messages.OnChange := MessagesChanged;
end;

procedure TFormMain.TimerRefreshTimer(Sender: TObject);
begin
  FormCPU.Reload;
  FormOutput.Reload;
  FormMemory.Reload;
end;

procedure TFormMain.TargetLogExecute(Lines: TStrings);
begin
  if Assigned(FormLog) then
    FormLog.Memo1.Lines.AddStrings(Lines);
end;

procedure TFormMain.TargetStateChanged(Sender: TObject);
begin
  UpdateInterface;
  if Core.Core.CurrentTarget.State = rsPaused then
    AProgramShowExecutionPoint.Execute;
  if Core.Core.CurrentTarget.State = rsStopped then
    Core.Core.Messages.AddMessage(SProgramStopped);
end;

procedure TFormMain.MessagesChanged(Sender: TObject);
begin
  FormMessages.Reload;
end;

procedure TFormMain.MenuItemTargetClick(Sender: TObject);
var
  I: Integer;
begin
  if Sender is TMenuItem then
  with TMenuItem(Sender) do begin
    Core.Core.CurrentTarget := Core.Core.Targets[MenuIndex];
    Checked := True;
    for I := 0 to Parent.Count - 1 do
      if Parent.Items[I].MenuIndex <> MenuIndex then Parent.Items[I].Checked := False;
  end;
end;

procedure TFormMain.ProjectOpen(FileName: string);
begin
  with Core.Core do begin
    if Project.Openned then
      raise Exception.Create(SCloseProjectFirst);
    FormSourceCode.SynEditSource.Lines.LoadFromFile(FileName);
    AddItemToLastOpenedList(FileName);
    Project.FileName := FileName;
    Project.Openned := True;
    CurrentTarget.Compiled := False;
  end;
  UpdateInterface;
end;

procedure TFormMain.UpdateToolBarHints;
var
  I: Integer;
begin
  for I := 0 to ToolBarMain.ControlCount - 1 do
    ToolBarMain.Controls[I].Hint := ToolBarMain.Controls[I].Caption;
end;

procedure TFormMain.DockForm(Form: TForm; DockSite: TWinControl);
begin
  Form.ManualDock(DockSite, nil, alClient);
  Form.Align := alClient;
  Form.Show;
end;

procedure TFormMain.DockInit;
begin
  DockForm(FormSourceCode, TabSheetSource);
  DockForm(FormTargetCode, TabSheetTarget);
  DockForm(FormCPU, PanelCPU);
  DockForm(FormInput, PanelInput);
  DockForm(FormOutput, PanelOutput);
  DockForm(FormMemory, PanelMemory);
  DockForm(FormMessages, TabSheetMessages);
  PageControlRight.Width := Width div 3;
  PageControlBottom.Height := Height div 5;
end;

procedure TFormMain.LastOpenedListChange(Sender: TObject);
begin
  Core.Core.LastOpenedList.LoadToMenuItem(MenuItemOpenRecent, AProjectOpenRecentExecute);
  Core.Core.LastOpenedList.LoadToMenuItem(PopupMenuRecentFiles.Items, AProjectOpenRecentExecute);
end;

procedure TFormMain.CurrentTargetChangeExecute(Sender: TObject);
begin
  UpdateTargetList;
  UpdateInterface;
end;

procedure TFormMain.UpdateInterface;
var
  Title: string;
  CanDebug: Boolean;
begin
  Title := '';
  with Core.Core do begin
    if Project.FileName <> '' then Title := Project.FileName;
    if Project.Modified then Title := Title + ' (' + SChanged + ')';
    Title:= Title + ' - ' + ApplicationInfo.AppName;
    Caption := Title;
    AProjectSave.Enabled := Project.Modified;
    FormSourceCode.SynEditSource.Enabled := Project.Openned;
    AProjectClose.Enabled := Project.Openned;
    AProjectSaveAs.Enabled := Project.Openned;
    AProgramRun.Enabled := (tcRun in CurrentTarget.Capabilities) and
      Project.Openned and (CurrentTarget.State = rsStopped) or (CurrentTarget.State = rsPaused);
    AProgramPause.Enabled := (tcPause in CurrentTarget.Capabilities) and
      Project.Openned and (CurrentTarget.State = rsRunning);
    AProgramStop.Enabled := (tcStop in CurrentTarget.Capabilities) and
      Project.Openned and (CurrentTarget.State <> rsStopped);
    AProgramCompile.Enabled := (tcCompile in CurrentTarget.Capabilities) and
      Project.Openned;
    CanDebug := DebugEnabled and Project.Openned and
      ((CurrentTarget.State = rsPaused) or (CurrentTarget.State = rsStopped));
    AProgramStepInto.Enabled := CanDebug and (tcStepInto in CurrentTarget.Capabilities);
    AProgramStepOut.Enabled := CanDebug and (tcStepOut in CurrentTarget.Capabilities);
    AProgramRunToCursor.Enabled := CanDebug and (tcRunToCursor in CurrentTarget.Capabilities);
    AProgramStepOver.Enabled := CanDebug and (tcStepOver in CurrentTarget.Capabilities);
    AProgramShowExecutionPoint.Enabled := CanDebug and (tcPause in CurrentTarget.Capabilities);
    AShowSourcePosition.Enabled := CurrentTarget.Compiled;
    AShowTargetPosition.Enabled := CurrentTarget.Compiled;
  end;
  UpdateStatusBar;
end;

procedure TFormMain.UpdateStatusBar;
begin
  StatusBarMain.Panels[0].Text := IntToStr(FormSourceCode.SynEditSource.CaretXY.X) +
    ', ' + IntToStr(FormSourceCode.SynEditSource.CaretXY.Y);
end;

procedure TFormMain.UpdateTargetList;
var
  I: Integer;
begin
  Core.Core.Targets.LoadToMenuItem(MenuItemTarget, MenuItemTargetClick, Core.Core.CurrentTarget);
  Core.Core.Targets.LoadToMenuItem(PopupMenuTargets.Items, MenuItemTargetClick, Core.Core.CurrentTarget);

  // Update toolbutton
  I := Core.Core.Targets.IndexOf(Core.Core.CurrentTarget);
  if I <> -1 then
  with TTarget(Core.Core.Targets[I]) do begin
    ToolButtonTarget.ImageIndex := ImageIndex;
    ToolButtonTarget.Caption := Name;
    ToolButtonTarget.OnClick := MenuItemTargetClick();
  end;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Core.Core.Translator.TranslateComponentRecursive(Self);
  Core.Core.ThemeManager.UseTheme(Self);

  FormSourceCode := TFormSourceCode.Create(nil);
  FormCPU := TFormCPU.Create(nil);
  FormInput := TFormInput.Create(nil);
  FormLog := TFormLog.Create(nil);
  FormMemory := TFormMemory.Create(nil);
  FormMessages := TFormMessages.Create(nil);
  FormOutput := TFormOutput.Create(nil);
  FormTargetCode := TFormTargetCode.Create(nil);

  UpdateTargetList;
  with Core.Core do begin
    LastOpenedList.OnChange := LastOpenedListChange;
    OnCurrentTargetChange := CurrentTargetChangeExecute;
    OnTargetChangeState := TargetStateChanged;
    OnTargetLog := TargetLogExecute;
  end;
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FormSourceCode);
  FreeAndNil(FormCPU);
  FreeAndNil(FormInput);
  FreeAndNil(FormLog);
  FreeAndNil(FormMemory);
  FreeAndNil(FormMessages);
  FreeAndNil(FormOutput);
  FreeAndNil(FormTargetCode);
end;

procedure TFormMain.AProgramRunExecute(Sender: TObject);
begin
  if Core.Core.CurrentTarget is TTargetInterpretter then
    TTargetInterpretter(Core.Core.CurrentTarget).Input := FormInput.MemoInput.Lines.Text;
  if not Core.Core.CurrentTarget.Compiled then AProgramCompile.Execute;
  Core.Core.CurrentTarget.Run;
  Core.Core.Messages.AddMessage(SProgramStarted);
end;

procedure TFormMain.AShowSourcePositionExecute(Sender: TObject);
var
  DebugStep: TDebugStep;
begin
  DebugStep := Core.Core.CurrentTarget.DebugSteps.SearchByTargetPos(FormTargetCode.SynEditTarget.SelStart - 1);
  if Assigned(DebugStep) then begin
    FormSourceCode.SynEditSource.SelStart := DebugStep.SourcePosition + 1;
    PageControlMain.TabIndex := 0;
  end;
end;

procedure TFormMain.AShowTargetPositionExecute(Sender: TObject);
var
  DebugStep: TDebugStep;
begin
  DebugStep := Core.Core.CurrentTarget.DebugSteps.SearchBySourcePos(FormSourceCode.SynEditSource.SelStart - 1);
  if Assigned(DebugStep) then begin
    FormTargetCode.SynEditTarget.SelStart := DebugStep.TargetPosition + 1;
    PageControlMain.TabIndex := 1;
  end;
end;

procedure TFormMain.AViewCompilersExecute(Sender: TObject);
begin
  with TFormTargets.Create(nil) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TFormMain.AViewInterpretterExecute(Sender: TObject);
begin
  FormCPU.Show;
end;

procedure TFormMain.AViewLogExecute(Sender: TObject);
begin
  if not Assigned(FormLog) then FormLog := TFormLog.Create(Self);
  FormLog.Show;
end;

procedure TFormMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Core.Core.PersistentForm1.Save(Self);
  Application.Terminate;
end;

procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if Core.Core.Project.Modified then begin
    AProjectClose.Execute;
    if Core.Core.Project.Openned then CanClose := False;
  end;
end;

procedure TFormMain.AExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.AOptionsExecute(Sender: TObject);
var
  FormOptions: TFormOptions;
begin
  FormOptions := TFormOptions.Create(nil);
  try
    FormOptions.Load;
    if FormOptions.ShowModal = mrOK then begin
      FormOptions.Save;
      if Assigned(Core.Core.CurrentTarget) then begin
        Core.Core.CurrentTarget.OptimizationLevel := Core.Core.OptimizationLevel;
        if Core.Core.CurrentTarget is TBFTarget then begin
          TBFTarget(Core.Core.CurrentTarget).CellSize := Core.Core.CellSize;
          TBFTarget(Core.Core.CurrentTarget).MemorySize := Core.Core.MemorySize;
        end;
      end;
      Core.Core.ThemeManager.UseTheme(Self);
      FormSourceCode.UpdateTheme;
      Core.Core.SaveToRegistry(Core.Core.ApplicationInfo.GetRegistryContext);
    end;
  finally
    FormOptions.Free;
  end;
end;

procedure TFormMain.AProgramCompileExecute(Sender: TObject);
begin
  with Core.Core, CurrentTarget do
  try
    Messages.Clear;
    AProgramStop.Execute;
    SourceCode := FormSourceCode.SynEditSource.Text;
    ProjectFileName := Project.FileName;
    ProgramName := ExtractFileNameOnly(Project.FileName);
    if CurrentTarget is TBFTarget then
      TBFTarget(CurrentTarget).Optimizations := Optimizations;
    DebugEnabled := DebugEnabled;
    Messages.AddMessage(SCompileStart);
    Application.ProcessMessages;
    Compile;
    Messages.AppendMessage(SDone);
    FormTargetCode.SynEditTarget.Text := TargetCode;
    FormTargetCode.SetHighlighter(CurrentTarget.SourceExtension);
    UpdateInterface;
  except
    on E: Exception do
      MessageDlg(SError, E.Message, mtError, [mbOk], 0);
  end;
end;

procedure TFormMain.AProgramCompileMultipleExecute(Sender: TObject);
var
  I: Integer;
begin
  AProgramStop.Execute;
  with TFormCompileMultiple.Create(nil) do
  try
    Targets := Core.Core.Targets;
    if ShowModal = mrOk then begin
      Core.Core.Messages.Clear;
      for I := 0 to Targets.Count - 1 do
      with Targets[I] do
      if Selected then
      try
        AProgramStop.Execute;
        SourceCode := FormSourceCode.SynEditSource.Text;
        ProjectFileName := Core.Core.Project.FileName;
        ProgramName := ExtractFileNameOnly(Core.Core.Project.FileName);
        if Targets[I] is TBFTarget then
          TBFTarget(Targets[I]).Optimizations := Core.Core.Optimizations;
        DebugEnabled := Core.Core.DebugEnabled;
        Core.Core.Messages.AddMessage(Name + ' ' + SCompileStart);
        Application.ProcessMessages;
        Compile;
        Core.Core.Messages.AppendMessage(SDone);
        FormTargetCode.SynEditTarget.Text := TargetCode;
        FormTargetCode.SetHighlighter(Core.Core.CurrentTarget.SourceExtension);
        UpdateInterface;
      except
        on E: Exception do
          MessageDlg(SError, E.Message, mtError, [mbOk], 0);
      end;
    end;
  finally
    Free;
  end;
end;

procedure TFormMain.ABreakpointToggleExecute(Sender: TObject);
var
  DebugStep: TDebugStep;
  BreakPoint: TBreakPoint;
begin
  DebugStep := Core.Core.CurrentTarget.DebugSteps.SearchBySourcePos(FormSourceCode.SynEditSource.SelStart - 1);
  if Assigned(DebugStep) then begin
    BreakPoint := Core.Core.CurrentTarget.BreakPoints.SearchByTargetPos(DebugStep.ProgramPosition);
    if Assigned(BreakPoint) then
      Core.Core.CurrentTarget.BreakPoints.Delete(Core.Core.CurrentTarget.BreakPoints.IndexOf(BreakPoint))
      else Core.Core.CurrentTarget.BreakPoints.AddItem(DebugStep.ProgramPosition);
  end;
end;

procedure TFormMain.AAboutExecute(Sender: TObject);
begin
  Core.Core.AboutDialog.Show;
end;

procedure TFormMain.AProgramPauseExecute(Sender: TObject);
begin
  Core.Core.CurrentTarget.Pause;
end;

procedure TFormMain.AProgramRunToCursorExecute(Sender: TObject);
var
  DebugStep: TDebugStep;
begin
  if Core.Core.CurrentTarget.State = rsStopped then begin
    if not Core.Core.CurrentTarget.Compiled then AProgramCompile.Execute;
    DebugStep := Core.Core.CurrentTarget.DebugSteps.SearchBySourcePos(FormSourceCode.SynEditSource.SelStart - 1);
    Core.Core.CurrentTarget.BreakPoints.SetSystem(DebugStep.ProgramPosition);
    AProgramRun.Execute;
  end else begin
    DebugStep := Core.Core.CurrentTarget.DebugSteps.SearchBySourcePos(FormSourceCode.SynEditSource.SelStart - 1);
    Core.Core.CurrentTarget.RunToCursor(DebugStep.ProgramPosition);
  end;
end;

procedure TFormMain.AProgramShowExecutionPointExecute(Sender: TObject);
var
  DebugStep: TDebugStep;
begin
  DebugStep := Core.Core.CurrentTarget.DebugSteps.SearchByProgramPos(
    Core.Core.CurrentTarget.ExecutionPosition);
  FormSourceCode.SynEditSource.SelStart := DebugStep.SourcePosition + 1;
  FormTargetCode.SynEditTarget.SelStart := DebugStep.TargetPosition + 1;
  if PageControlMain.TabIndex = 0 then FormSourceCode.SynEditSource.SetFocus;
  if PageControlMain.TabIndex = 1 then FormTargetCode.SynEditTarget.SetFocus;
end;

procedure TFormMain.AProgramStepIntoExecute(Sender: TObject);
begin
  if Core.Core.CurrentTarget.State = rsStopped then begin
    if not Core.Core.CurrentTarget.Compiled then AProgramCompile.Execute;
    Core.Core.CurrentTarget.BreakPoints.SetSystem(
      Core.Core.CurrentTarget.DebugSteps.First.ProgramPosition);
    AProgramRun.Execute;
  end else Core.Core.CurrentTarget.StepInto;
end;

procedure TFormMain.AProgramStepOutExecute(Sender: TObject);
begin
  Core.Core.CurrentTarget.StepOut;
end;

procedure TFormMain.AProgramStepOverExecute(Sender: TObject);
begin
  if Core.Core.CurrentTarget.State = rsStopped then begin
    if not Core.Core.CurrentTarget.Compiled then AProgramCompile.Execute;
    Core.Core.CurrentTarget.BreakPoints.SetSystem(
      TDebugStep(Core.Core.CurrentTarget.DebugSteps.First).ProgramPosition);
    AProgramRun.Execute;
  end else Core.Core.CurrentTarget.StepOver;
end;

procedure TFormMain.AProgramStopExecute(Sender: TObject);
begin
  Core.Core.CurrentTarget.Stop;
end;

procedure TFormMain.AProjectCloseExecute(Sender: TObject);
var
  DialogResult: TModalResult;
begin
  DialogResult := mrNo;
  if Core.Core.Project.Modified then begin
    DialogResult := MessageDlg(SUnsavedChanges, SDoYouWantToSaveProject, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if DialogResult = mrYes then begin
      AProjectSave.Execute;
    end;
  end;
  if (DialogResult = mrNo) or (DialogResult = mrYes) then begin
    AProgramStop.Execute;
    Core.Core.Project.Openned := False;
    FormSourceCode.SynEditSource.Clear;
    UpdateInterface;
  end;
end;

procedure TFormMain.AProjectNewExecute(Sender: TObject);
begin
  AProjectClose.Execute;
  if Core.Core.Project.Openned then Exit;
  Core.Core.Project.FileName := CombinePaths(Core.Core.DataDir, ExamplesDir + DirectorySeparator + SNewProject + '.b');
  FormSourceCode.SynEditSource.Clear;
  Core.Core.Project.Openned := True;
  Core.Core.CurrentTarget.Compiled := False;
  UpdateInterface;
end;

procedure TFormMain.AProjectOpenRecentExecute(Sender: TObject);
var
  FileName: string;
begin
  FileName := Core.Core.LastOpenedList.Items[TMenuItem(Sender).MenuIndex];
  if FileExists(FileName) then begin
    AProjectClose.Execute;
    if Core.Core.Project.Openned then Exit;
    ProjectOpen(FileName);
  end else ShowMessage(Format(SFileNotFound, [FileName]));
end;

procedure TFormMain.AProjectOpenExecute(Sender: TObject);
var
  FileName: string;
begin
  if Core.Core.LastOpenedList.Items.Count > 0 then
    FileName := Core.Core.LastOpenedList.Items[0]
    else FileName := CombinePaths(Core.Core.DataDir, ExamplesDir);
  OpenDialog1.InitialDir := ExtractFileDir(FileName);
  OpenDialog1.FileName := ExtractFileName(FileName);
  if OpenDialog1.Execute then begin
    AProjectClose.Execute;
    if Core.Core.Project.Openned then Exit;
    ProjectOpen(OpenDialog1.FileName);
  end;
end;

procedure TFormMain.AProjectSaveAsExecute(Sender: TObject);
begin
  SaveDialog1.InitialDir := ExtractFileDir(Core.Core.Project.FileName);
  SaveDialog1.FileName := ExtractFileName(Core.Core.Project.FileName);
  if SaveDialog1.Execute then begin
    FormSourceCode.SynEditSource.Lines.SaveToFile(SaveDialog1.FileName);
    Core.Core.Project.FileName := SaveDialog1.FileName;
    Core.Core.AddItemToLastOpenedList(SaveDialog1.FileName);
    Core.Core.Project.Modified := False;
    UpdateInterface;
  end;
end;

procedure TFormMain.AProjectSaveExecute(Sender: TObject);
begin
  if Core.Core.Project.Modified and FileExists(Core.Core.Project.FileName) then begin
    FormSourceCode.SynEditSource.Lines.SaveToFile(Core.Core.Project.FileName);
    Core.Core.AddItemToLastOpenedList(Core.Core.Project.FileName);
    Core.Core.Project.Modified := False;
    UpdateInterface;
  end else AProjectSaveAs.Execute;
end;

end.

