unit FormOutput;

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TFormOutput }

  TFormOutput = class(TForm)
    Label2: TLabel;
    MemoOutput: TMemo;
    procedure FormCreate(Sender: TObject);
  public
    procedure Reload;
  end;


implementation

{$R *.lfm}

uses
  Core, TargetInterpretter;

{ TFormOutput }

procedure TFormOutput.FormCreate(Sender: TObject);
begin
  Core.Core.Translator.TranslateComponentRecursive(Self);
  Core.Core.ThemeManager.UseTheme(Self);
end;

procedure TFormOutput.Reload;
begin
  if Core.Core.CurrentTarget is TTargetInterpretter then
  with TTargetInterpretter(Core.Core.CurrentTarget) do begin
    if OutputChanged then begin
      OutputChanged := False;
      {$IFDEF UNIX}
      MemoOutput.Lines.Text := StringReplace(Output, #10#13, LineEnding, [rfReplaceAll])
      {$ELSE}
      MemoOutput.Lines.Text := Output;
      {$ENDIF}
    end;
  end;
end;

end.

