unit FormTargetCode;

interface

uses
  Classes, SysUtils, FileUtil, SynEdit, SynHighlighterAny, SynHighlighterPas,
  SynHighlighterCpp, SynHighlighterPHP, SynHighlighterJava,
  SynHighlighterPython, SynHighlighterJScript, Forms, Controls, Graphics,
  Dialogs, Menus, ActnList, strutils;

type

  { TFormTargetCode }

  TFormTargetCode = class(TForm)
    AShrinkCode: TAction;
    AFormatCode: TAction;
    ActionList1: TActionList;
    MenuItem1: TMenuItem;
    MenuItem20: TMenuItem;
    PopupMenuTarget: TPopupMenu;
    SynEditTarget: TSynEdit;
    procedure AFormatCodeExecute(Sender: TObject);
    procedure AShrinkCodeExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    procedure SetHighlighter(SourceExt: string);
  end;


implementation

{$R *.lfm}

uses
  Core;

{ TFormTargetCode }

procedure TFormTargetCode.AFormatCodeExecute(Sender: TObject);
var
  Source: string;
  NewSource: string;
  Indent: Integer;
  I: Integer;
const
  IndentText = '  ';
begin
  Source := SynEditTarget.Text;
  NewSource := '';
  Indent := 0;
  for I := 1 to Length(Source) do begin
    if Source[I] = '[' then begin
      NewSource := NewSource + LineEnding + DupeString(IndentText, Indent) + Source[I] + LineEnding ;
      Inc(Indent);
      NewSource := NewSource + DupeString(IndentText, Indent);
    end
    else if Source[I] = ']' then begin
      Dec(Indent);
      NewSource := NewSource + LineEnding + DupeString(IndentText, Indent) + Source[I] + LineEnding + DupeString(IndentText, Indent);
    end
    else if Ord(Source[I]) > $20 then
      NewSource := NewSource + Source[I];
  end;
  SynEditTarget.Text := NewSource;
end;

procedure TFormTargetCode.AShrinkCodeExecute(Sender: TObject);
var
  Source: string;
  Pos: Integer;
  I: Integer;
begin
  Source := SynEditTarget.Text;
  Pos := 1;
  for I := 1 to Length(Source) do begin
    if Source[I] > ' ' then begin
      Source[Pos] := Source[I];
      Inc(Pos);
    end;
  end;
  SetLength(Source, Pos - 1);
  SynEditTarget.Text := Source;
end;

procedure TFormTargetCode.FormCreate(Sender: TObject);
begin
  Core.Core.Translator.TranslateComponentRecursive(Self);
  Core.Core.ThemeManager.UseTheme(Self);
end;

procedure TFormTargetCode.SetHighlighter(SourceExt: string);
begin
  if Assigned(SynEditTarget.Highlighter) then
    SynEditTarget.Highlighter.Free;
  if SourceExt = '.pas' then SynEditTarget.Highlighter := TSynPasSyn.Create(nil)
  else if SourceExt = '.c' then SynEditTarget.Highlighter := TSynCppSyn.Create(nil)
  else if SourceExt = '.php' then SynEditTarget.Highlighter := TSynPhpSyn.Create(nil)
  else if SourceExt = '.java' then SynEditTarget.Highlighter := TSynJavaSyn.Create(nil)
  else if SourceExt = '.py' then SynEditTarget.Highlighter := TSynPythonSyn.Create(nil)
  else if SourceExt = '.js' then SynEditTarget.Highlighter := TSynJScriptSyn.Create(nil);
end;

end.

