unit FormTargets;

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls;

type

  { TFormTargets }

  TFormTargets = class(TForm)
    ListView1: TListView;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListView1Data(Sender: TObject; Item: TListItem);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1KeyPress(Sender: TObject; var Key: char);
  public
    procedure ReloadList;
  end; 


implementation

{$R *.lfm}

uses
  Core, Target, FormTargetOptions;

{ TFormTargets }

procedure TFormTargets.FormShow(Sender: TObject);
begin
  Core.Core.PersistentForm1.Load(Self);
  ReloadList;
end;

procedure TFormTargets.FormCreate(Sender: TObject);
begin
  Core.Core.Translator.TranslateComponentRecursive(Self);
  Core.Core.ThemeManager.UseTheme(Self);
end;

procedure TFormTargets.FormClose(Sender: TObject; var CloseAction: TCloseAction
  );
begin
  Core.Core.PersistentForm1.Save(Self);
end;

procedure TFormTargets.ListView1Data(Sender: TObject; Item: TListItem);
begin
  if (Item.Index >= 0) and (Item.Index < Core.Core.Targets.Count) then
  with TTarget(Core.Core.Targets[Item.Index]) do begin
    Item.Caption := Name;
    Item.Data := Core.Core.Targets[Item.Index];
    Item.SubItems.Add(ExecutorPath);
    Item.SubItems.Add(CompilerPath);
  end;
end;

procedure TFormTargets.ListView1DblClick(Sender: TObject);
var
  FormTargetOptions: TFormTargetOptions;
begin
  FormTargetOptions := TFormTargetOptions.Create(nil);
  try
    FormTargetOptions.LoadControls(TTarget(ListView1.Selected.Data));
    if FormTargetOptions.ShowModal = mrOk then begin
      FormTargetOptions.SaveControls(TTarget(ListView1.Selected.Data));
      ReloadList;
    end;
  finally
    FormTargetOptions.Free;
  end;
end;

procedure TFormTargets.ListView1KeyPress(Sender: TObject; var Key: char);
begin
  if Key = #13 then ListView1DblClick(nil);
end;

procedure TFormTargets.ReloadList;
begin
  ListView1.Items.Count := Core.Core.Targets.Count;
  ListView1.Refresh;
end;

end.

