Name:           LazFuck
Version:        1.3.0
Release:        1%{?dist}
Summary:        A simple BrainFuck IDE written in Lazarus/FPC.

Group:          Applications/Development
License:        Public Domain
URL:            https://app.zdechov.net/LazFuck
Source0:        LazFuck.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

#BuildRequires:  lazarus

%description
LazFuck is GUI application for writing, executing, compiling and debugging programs written in famous BrainFuck esoteric programming language. 

Features:
* Graphical code editor with color syntax highlighting
* Cross-compilation to Delphi, Free Pascal, Python, Java, C, C#, PHP, and Javascript
* Interpreter with debugger 

%global debug_package %{nil}

%prep
%setup -q -c $(RPM_NAME)-$(RPM_VERSION)


%build
lazbuild --build-mode=Release LazFuck.lpi

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT/usr/bin
install -s -m 755 LazFuck $RPM_BUILD_ROOT/usr/bin
install -d -m 755 $RPM_BUILD_ROOT/usr/share/LazFuck/Languages
install -m 644 Languages/LazFuck.pot $RPM_BUILD_ROOT/usr/share/LazFuck/Languages
install -m 644 Languages/LazFuck.cs.po $RPM_BUILD_ROOT/usr/share/LazFuck/Languages
install -m 644 Languages/UFormAbout.pot $RPM_BUILD_ROOT/usr/share/LazFuck/Languages
install -m 644 Languages/UFormAbout.cs.po $RPM_BUILD_ROOT/usr/share/LazFuck/Languages
install -d -m 755 $RPM_BUILD_ROOT/usr/share/applications
install -m 644 Install/deb/LazFuck.desktop $RPM_BUILD_ROOT/usr/share/applications
install -d -m 755 $RPM_BUILD_ROOT/usr/share/pixmaps
install -m 644 Images/64x64/LazFuck.png $RPM_BUILD_ROOT/usr/share/pixmaps
install -d -m 755 $RPM_BUILD_ROOT/usr/share/mime/packages
install -m 644 Install/deb/LazFuck.xml $RPM_BUILD_ROOT/usr/share/mime/packages
cp -r Examples $RPM_BUILD_ROOT/usr/share/LazFuck

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
/usr/bin/LazFuck
/usr/share/applications/LazFuck.desktop
/usr/share/LazFuck/*
/usr/share/pixmaps/LazFuck.png
/usr/share/mime/packages/LazFuck.xml

%changelog
